#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    solve();
}

vector<vector<int>> graph;
vector<int> used;
int mx = 0, mx2 = 0;

void dfs(int v, int cnt) {
    used[v] = true;
    for (int u: graph[v]) {
        if (!used[u]) {
            dfs(u, cnt + 1);
        }
    }
    if (cnt >= mx) {
        mx2 = mx;
        mx = cnt;
    }
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    graph.resize(n);
    used.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }

    if (t == 0) {
        for (int i = 1; i <= n; ++i) {
            if ((i + 1) * (k + 1) >= n) {
                cout << i;
                return;
            }
        }
    }

}