#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using ll = long long;
vector<ll> w, h;
vector<pair<ll, int>> hpr;
vector<vector<int>> a;
int n, m;
int IND = -1;
ll s;
int VIb;
int ans1 = 1, ans2 = 2;

void rech(ll sum) {
    vector<vector<bool>> dp(IND + 1, vector<bool>(sum + 1));
    vector<vector<int>> pred(IND + 1, vector<int>(sum + 1, -1));
    for (int i = 0; i <= IND; ++i) {
        dp[i][0] = true;
    }
    for (int i = 1; i <= IND; ++i) {
        for (int sm = 0; sm < sum + 1; ++sm) {
            dp[i][sm] = dp[i - 1][sm];
            if (sm - hpr[i - 1].first >= 0 && dp[i - 1][sm - hpr[i - 1].first]) {
                dp[i][sm] = true;
                pred[i][sm] = i - 1;
            }

        }
    }
    if (dp[IND][sum] == true) {
        vector<pair<int, int>> ans;
        for (int i = IND; i >= 0; --i) {
            if (pred[i][sum] == -1)continue;
            int j = pred[i][sum];
            sum -= hpr[j].first;
            ans.emplace_back(ans1, hpr[j].second + 1);
            if (sum == 0) break;
        }
        for (int i = 0; i < m; ++i) {
            if ((1 << i) & VIb) {
                ans.emplace_back(ans2, i + 1);
            }
        }
        cout << "YES\n";
        cout << ans.size() << '\n';
        for (auto i: ans) {
            cout << i.first << ' ' << i.second << '\n';
        }
        exit(0);
    }
}

void recw(int ind, ll sum, int vib) {
    if (sum < s) return;
    if (ind == m) {
        hpr.assign(n, {0, 0});
        for (int i = 0; i < n; ++i) {
            hpr[i].first = h[i];
            hpr[i].second = i;
        }
        for (int i = 0; i < m; ++i) {
            if ((1 << i) & vib) {
                for (int j = 0; j < n; ++j) {
                    hpr[j].first -= a[j][i];
                }
            }
        }
        sort(hpr.begin(), hpr.end());
        ll sf = 0;
        for (int i = 0; i < n; ++i) {
            if (sum - hpr[i].first < s) {
                IND = i;
                break;
            }
            sf += hpr[i].first;
        }
        if (IND == -1) {
            IND = n;
        }

        VIb = vib;
        if (sum - sf <= s) {
            rech(sum - s);
        }
        IND = -1;
        return;
    }
    recw(ind + 1, sum, vib);
    vib ^= (1 << ind);
    recw(ind + 1, sum - w[ind], vib);
}

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    a.resize(n, vector<int>(m));
    w.resize(m);
    h.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            h[i] += a[i][j];
        }
    }
    cin >> s;
    ll sum = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            w[i] += a[j][i];
        }
        sum += w[i];
    }
    if (sum > s) {
        if (m > n) {
            swap(w, h);
            swap(n, m);
            swap(ans2, ans1);
            vector<vector<int>> a1(n, vector<int>(m));
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    a1[i][j] = a[j][i];
                }
            }
            a = a1;
        }
        recw(0, sum, 0);
        cout << "NO\n";
    } else if (s == sum) {
        cout << "YES\n";
        cout << 0;
    } else {
        cout << "NO\n";
    }

}