#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    solve();
}

vector<vector<int>> graph;
vector<int> used;
int mx = 0, mx2 = 0, ver1 = -1, ver2 = -1;
int tin[int(1e5)], tout[int(1e5)];
int timer = 1;

void dfs(int v, int cnt) {
    used[v] = true;
    tin[v] = timer++;
    for (int u: graph[v]) {
        if (!used[u]) {
            dfs(u, cnt + 1);
        }
    }
    if (cnt >= mx) {
        ver2 = ver1;
        ver1 = v;
        mx2 = mx;
        mx = cnt;
    }
    tout[v] = timer++;
}

int ans1 = mx;

bool isPred(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void dfs1(int v, int cnt = 0) {
    used[v] = true;
    for (auto u: graph[v]) {
        if (!used[u] && isPred(u, ver1) && isPred(u, ver2)) {
            dfs1(u, cnt++);
        }
    }
    if (isPred(v, ver1) && isPred(v, ver2)) {
        ans1 = min(ans1, mx - cnt + 1);
    }


}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    graph.resize(n);
    used.resize(n);
    bool b = true;
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (v + 1 != u) b = false;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }

    if (t == 0 && b) {
        for (int i = 0; i <= n; ++i) {
            if ((i) * (k + 1) >= n) {
                cout << i;
                return;
            }
        }
    }
    dfs(0, 0);
    used.assign(n, 0);
    dfs1(0, 0);
    cout << min(ans1, max(mx / 2, mx2));
}