#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    solve();
}
map<int, vector<int>> m;
vector<vector<int>> graph;
vector<int> used;
vector<int> ans;
vector<int> fg;

void dfs(int v, int k) {
    used[v] = true;
    for (auto i: m[fg[v]]) {
        ans[i] = k + 1;
    }
    for (auto u: graph[v]) {
        if (!used[u]) {
            dfs(u, 1 - k);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int h;
        cin >> h;
        m[h].push_back(i);
        fg.push_back(h);
    }
    ans.resize(n);
    sort(fg.begin(), fg.end());
    fg.resize(unique(fg.begin(), fg.end()) - fg.begin());
    graph.resize(fg.size());
    used.resize(fg.size());
    for (auto [k, z]: m) {
        int j = 2, kk = k;
        set<int> d;
        while (j * j <= kk) {
            if (kk % j == 0) {
                kk /= j;
                d.insert(j);
            } else {
                j++;
            }
        }
        if (kk > 1) {
            d.insert(kk);
        }
        int indx1 = lower_bound(fg.begin(), fg.end(), k) - fg.begin();
        for (auto i: d) {
            if (m.find(k / i) != m.end()) {
                int indx2 = lower_bound(fg.begin(), fg.end(), k / i) - fg.begin();
                graph[indx1].push_back(indx2);
                graph[indx2].push_back(indx1);
            }
        }
    }
    for (int i = 0; i < fg.size(); ++i) {
        if (!used[i]) {
            dfs(i, 0);
        }
    }
    for (auto u: ans) {
        cout << u << ' ';
    }
}