#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    solve();
}


pair<int, int> d[int(4e5)];
#define mod first
#define z second

void push(int v) {
    if (d[v].mod == 0) return;
    d[2 * v + 1].z = d[v].mod;
    d[2 * v + 2].z = d[v].mod;
    d[2 * v + 1].mod = d[v].mod;
    d[2 * v + 2].mod = d[v].mod;
    d[v].mod = 0;
}

void update(int v, int l, int r, int ql, int qr, int x) {
    if (ql >= r || l >= qr) {
        return;
    }
    if (ql <= l && r <= qr) {
        d[v].mod = x;
        d[v].z = x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, ql, qr, x);
    update(2 * v + 2, m, r, ql, qr, x);
}

int get(int v, int l, int r, int indx) {
    if (l + 1 == r) {
        return d[v].z;
    }
    push(v);
    int m = (l + r) / 2;
    if (indx < m) {
        return get(2 * v + 1, l, m, indx);
    }
    return get(2 * v + 2, m, r, indx);
}

vector<int> l, r, siz;
int vipis = 0, n;

void rec(int v) {
    int type = get(0, 0, n, v);
    if (type == 1) {
        siz[v] = ++vipis;
    }
    if (l[v] > -1) {
        rec(l[v]);
    }
    if (type == 2) {
        siz[v] = ++vipis;
    }
    if (r[v] > -1) {
        rec(r[v]);
    }
    if (type == 3) {
        siz[v] = ++vipis;
    }
}

void solve() {
    int q;
    cin >> n >> q;
    for (int i = 0; i < 4e5; ++i) {
        d[i].mod = 0;
        d[i].z = 1;
    }
    l.resize(n);
    r.resize(n);
    siz.resize(n);
    set<int> st;
    for (int i = 0; i < n; ++i) {
        st.insert(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        l[i]--, r[i]--;
        st.erase(l[i]);
        st.erase(r[i]);
    }
    int root = *st.begin();
    bool b = false;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            b = false;
            int l1, r1, x;
            cin >> l1 >> r1 >> x;
            x += 2;
            l1--;
            update(0, 0, n, l1, r1, x);
        } else {
            int i;
            cin >> i;
            if (!b) {
                vipis = 0;
                rec(root);
            }
            cout << siz[--i] << '\n';
            b = true;
        }
    }

}





















//int n, m;
//cin >> n >> m;
//vector<int> ch(m);
//for (int i = 0; i < n; ++i) {
//int h;
//cin >> h;
//h--;
//ch[h]++;
//}
//for